import { record_type as Reflection_record_type, bool_type as Reflection_bool_type, list_type as Reflection_list_type, class_type as Reflection_class_type } from "./Reflection.js";
import { value as Option_value, some as Option_some } from "./Option.js";
import { List as Types_List } from "./Types.js";
import { delay as Seq_delay, collect as Seq_collect, singleton as Seq_singleton, empty as Seq_empty, fold as Seq_fold, reduce as Seq_reduce, toIterator as Seq_toIterator, map as Seq_map, getEnumerator as Seq_getEnumerator } from "./Seq.js";
import { fold as Array_fold } from "././Array.js";
import { structuralHash as Util_structuralHash, equals as Util_equals } from "./Util.js";
import { join as String_join, toString as String_toString } from "./String.js";
import { HashSet__Add_2B595 as MutableSet_HashSet__Add_2B595, HashSet_$ctor_Z6150332D as MutableSet_HashSet_$ctor_Z6150332D } from "././MutableSet.js";

export class SetTree$1 {
    constructor(k) {
        this.k = k;
    }
}

export function SetTree$1$reflection(gen0) {
    return Reflection_class_type("Set.SetTree`1", [gen0], SetTree$1);
}

export function SetTree$1_$ctor_2B595(k) {
    return new SetTree$1(k);
}

export function SetTree$1__get_Key(_) {
    return _.k;
}

export class SetTreeNode$1 extends SetTree$1 {
    constructor(v, left, right, h) {
        super(v);
        this.left = left;
        this.right = right;
        this.h = h;
    }
}

export function SetTreeNode$1$reflection(gen0) {
    return Reflection_class_type("Set.SetTreeNode`1", [gen0], SetTreeNode$1);
}

export function SetTreeNode$1_$ctor_Z7A150ED7(v, left, right, h) {
    return new SetTreeNode$1(v, left, right, h);
}

export function SetTreeNode$1__get_Left(_) {
    return _.left;
}

export function SetTreeNode$1__get_Right(_) {
    return _.right;
}

export function SetTreeNode$1__get_Height(_) {
    return _.h;
}

export function SetTreeModule_empty() {
    return null;
}

export function SetTreeModule_countAux(t_mut, acc_mut) {
    SetTreeModule_countAux:
    while (true) {
        const t = t_mut, acc = acc_mut;
        if (t == null) {
            return acc | 0;
        }
        else if (t instanceof SetTreeNode$1) {
            t_mut = SetTreeNode$1__get_Left(t);
            acc_mut = SetTreeModule_countAux(SetTreeNode$1__get_Right(t), acc + 1);
            continue SetTreeModule_countAux;
        }
        else {
            return (acc + 1) | 0;
        }
        break;
    }
}

export function SetTreeModule_count(s) {
    return SetTreeModule_countAux(s, 0);
}

export function SetTreeModule_mk(l, k, r) {
    const hl = ((l == null) ? 0 : ((l instanceof SetTreeNode$1) ? SetTreeNode$1__get_Height(l) : 1)) | 0;
    const hr = ((r == null) ? 0 : ((r instanceof SetTreeNode$1) ? SetTreeNode$1__get_Height(r) : 1)) | 0;
    const m = ((hl < hr) ? hr : hl) | 0;
    if (m === 0) {
        return SetTree$1_$ctor_2B595(k);
    }
    else {
        return SetTreeNode$1_$ctor_Z7A150ED7(k, l, r, m + 1);
    }
}

export function SetTreeModule_rebalance(t1, v, t2) {
    let t_4, t_6;
    const t1h = ((t1 == null) ? 0 : ((t1 instanceof SetTreeNode$1) ? SetTreeNode$1__get_Height(t1) : 1)) | 0;
    const t2h = ((t2 == null) ? 0 : ((t2 instanceof SetTreeNode$1) ? SetTreeNode$1__get_Height(t2) : 1)) | 0;
    if (t2h > (t1h + 2)) {
        if ((t_4 = SetTreeNode$1__get_Left(t2), (t_4 == null) ? 0 : ((t_4 instanceof SetTreeNode$1) ? SetTreeNode$1__get_Height(t_4) : 1)) > (t1h + 1)) {
            let t2l;
            const value_1 = SetTreeNode$1__get_Left(t2);
            t2l = value_1;
            return SetTreeModule_mk(SetTreeModule_mk(t1, v, SetTreeNode$1__get_Left(t2l)), SetTree$1__get_Key(t2l), SetTreeModule_mk(SetTreeNode$1__get_Right(t2l), SetTree$1__get_Key(t2), SetTreeNode$1__get_Right(t2)));
        }
        else {
            return SetTreeModule_mk(SetTreeModule_mk(t1, v, SetTreeNode$1__get_Left(t2)), SetTree$1__get_Key(t2), SetTreeNode$1__get_Right(t2));
        }
    }
    else if (t1h > (t2h + 2)) {
        if ((t_6 = SetTreeNode$1__get_Right(t1), (t_6 == null) ? 0 : ((t_6 instanceof SetTreeNode$1) ? SetTreeNode$1__get_Height(t_6) : 1)) > (t2h + 1)) {
            let t1r;
            const value_3 = SetTreeNode$1__get_Right(t1);
            t1r = value_3;
            return SetTreeModule_mk(SetTreeModule_mk(SetTreeNode$1__get_Left(t1), SetTree$1__get_Key(t1), SetTreeNode$1__get_Left(t1r)), SetTree$1__get_Key(t1r), SetTreeModule_mk(SetTreeNode$1__get_Right(t1r), v, t2));
        }
        else {
            return SetTreeModule_mk(SetTreeNode$1__get_Left(t1), SetTree$1__get_Key(t1), SetTreeModule_mk(SetTreeNode$1__get_Right(t1), v, t2));
        }
    }
    else {
        return SetTreeModule_mk(t1, v, t2);
    }
}

export function SetTreeModule_add(comparer, k, t) {
    if (t == null) {
        return SetTree$1_$ctor_2B595(k);
    }
    else {
        const c = comparer.Compare(k, SetTree$1__get_Key(t)) | 0;
        if (t instanceof SetTreeNode$1) {
            if (c < 0) {
                return SetTreeModule_rebalance(SetTreeModule_add(comparer, k, SetTreeNode$1__get_Left(t)), SetTree$1__get_Key(t), SetTreeNode$1__get_Right(t));
            }
            else if (c === 0) {
                return t;
            }
            else {
                return SetTreeModule_rebalance(SetTreeNode$1__get_Left(t), SetTree$1__get_Key(t), SetTreeModule_add(comparer, k, SetTreeNode$1__get_Right(t)));
            }
        }
        else {
            const c_1 = comparer.Compare(k, SetTree$1__get_Key(t)) | 0;
            if (c_1 < 0) {
                return SetTreeNode$1_$ctor_Z7A150ED7(k, SetTreeModule_empty(), t, 2);
            }
            else if (c_1 === 0) {
                return t;
            }
            else {
                return SetTreeNode$1_$ctor_Z7A150ED7(k, t, SetTreeModule_empty(), 2);
            }
        }
    }
}

export function SetTreeModule_balance(comparer, t1, k, t2) {
    if (t1 == null) {
        return SetTreeModule_add(comparer, k, t2);
    }
    else if (t2 == null) {
        return SetTreeModule_add(comparer, k, t1);
    }
    else if (t1 instanceof SetTreeNode$1) {
        if (t2 instanceof SetTreeNode$1) {
            if ((SetTreeNode$1__get_Height(t1) + 2) < SetTreeNode$1__get_Height(t2)) {
                return SetTreeModule_rebalance(SetTreeModule_balance(comparer, t1, k, SetTreeNode$1__get_Left(t2)), SetTree$1__get_Key(t2), SetTreeNode$1__get_Right(t2));
            }
            else if ((SetTreeNode$1__get_Height(t2) + 2) < SetTreeNode$1__get_Height(t1)) {
                return SetTreeModule_rebalance(SetTreeNode$1__get_Left(t1), SetTree$1__get_Key(t1), SetTreeModule_balance(comparer, SetTreeNode$1__get_Right(t1), k, t2));
            }
            else {
                return SetTreeModule_mk(t1, k, t2);
            }
        }
        else {
            return SetTreeModule_add(comparer, k, SetTreeModule_add(comparer, SetTree$1__get_Key(t2), t1));
        }
    }
    else {
        return SetTreeModule_add(comparer, k, SetTreeModule_add(comparer, SetTree$1__get_Key(t1), t2));
    }
}

export function SetTreeModule_split(comparer, pivot, t) {
    if (t == null) {
        return [SetTreeModule_empty(), false, SetTreeModule_empty()];
    }
    else if (t instanceof SetTreeNode$1) {
        const c = comparer.Compare(pivot, SetTree$1__get_Key(t)) | 0;
        if (c < 0) {
            const patternInput = SetTreeModule_split(comparer, pivot, SetTreeNode$1__get_Left(t));
            return [patternInput[0], patternInput[1], SetTreeModule_balance(comparer, patternInput[2], SetTree$1__get_Key(t), SetTreeNode$1__get_Right(t))];
        }
        else if (c === 0) {
            return [SetTreeNode$1__get_Left(t), true, SetTreeNode$1__get_Right(t)];
        }
        else {
            const patternInput_1 = SetTreeModule_split(comparer, pivot, SetTreeNode$1__get_Right(t));
            return [SetTreeModule_balance(comparer, SetTreeNode$1__get_Left(t), SetTree$1__get_Key(t), patternInput_1[0]), patternInput_1[1], patternInput_1[2]];
        }
    }
    else {
        const c_1 = comparer.Compare(SetTree$1__get_Key(t), pivot) | 0;
        if (c_1 < 0) {
            return [t, false, SetTreeModule_empty()];
        }
        else if (c_1 === 0) {
            return [SetTreeModule_empty(), true, SetTreeModule_empty()];
        }
        else {
            return [SetTreeModule_empty(), false, t];
        }
    }
}

export function SetTreeModule_spliceOutSuccessor(t) {
    let t_2;
    if (t == null) {
        throw (new Error("internal error: Set.spliceOutSuccessor"));
    }
    else if (t instanceof SetTreeNode$1) {
        if (t_2 = SetTreeNode$1__get_Left(t), t_2 == null) {
            return [SetTree$1__get_Key(t), SetTreeNode$1__get_Right(t)];
        }
        else {
            const patternInput = SetTreeModule_spliceOutSuccessor(SetTreeNode$1__get_Left(t));
            return [patternInput[0], SetTreeModule_mk(patternInput[1], SetTree$1__get_Key(t), SetTreeNode$1__get_Right(t))];
        }
    }
    else {
        return [SetTree$1__get_Key(t), SetTreeModule_empty()];
    }
}

export function SetTreeModule_remove(comparer, k, t) {
    let t_2, t_3;
    if (t == null) {
        return t;
    }
    else {
        const c = comparer.Compare(k, SetTree$1__get_Key(t)) | 0;
        if (t instanceof SetTreeNode$1) {
            if (c < 0) {
                return SetTreeModule_rebalance(SetTreeModule_remove(comparer, k, SetTreeNode$1__get_Left(t)), SetTree$1__get_Key(t), SetTreeNode$1__get_Right(t));
            }
            else if (c === 0) {
                if (t_2 = SetTreeNode$1__get_Left(t), t_2 == null) {
                    return SetTreeNode$1__get_Right(t);
                }
                else if (t_3 = SetTreeNode$1__get_Right(t), t_3 == null) {
                    return SetTreeNode$1__get_Left(t);
                }
                else {
                    const patternInput = SetTreeModule_spliceOutSuccessor(SetTreeNode$1__get_Right(t));
                    return SetTreeModule_mk(SetTreeNode$1__get_Left(t), patternInput[0], patternInput[1]);
                }
            }
            else {
                return SetTreeModule_rebalance(SetTreeNode$1__get_Left(t), SetTree$1__get_Key(t), SetTreeModule_remove(comparer, k, SetTreeNode$1__get_Right(t)));
            }
        }
        else if (c === 0) {
            return SetTreeModule_empty();
        }
        else {
            return t;
        }
    }
}

export function SetTreeModule_mem(comparer_mut, k_mut, t_mut) {
    SetTreeModule_mem:
    while (true) {
        const comparer = comparer_mut, k = k_mut, t = t_mut;
        if (t == null) {
            return false;
        }
        else {
            const c = comparer.Compare(k, SetTree$1__get_Key(t)) | 0;
            if (t instanceof SetTreeNode$1) {
                if (c < 0) {
                    comparer_mut = comparer;
                    k_mut = k;
                    t_mut = SetTreeNode$1__get_Left(t);
                    continue SetTreeModule_mem;
                }
                else if (c === 0) {
                    return true;
                }
                else {
                    comparer_mut = comparer;
                    k_mut = k;
                    t_mut = SetTreeNode$1__get_Right(t);
                    continue SetTreeModule_mem;
                }
            }
            else {
                return c === 0;
            }
        }
        break;
    }
}

export function SetTreeModule_iter(f_mut, t_mut) {
    SetTreeModule_iter:
    while (true) {
        const f = f_mut, t = t_mut;
        if (t == null) {
        }
        else if (t instanceof SetTreeNode$1) {
            SetTreeModule_iter(f, SetTreeNode$1__get_Left(t));
            f(SetTree$1__get_Key(t));
            f_mut = f;
            t_mut = SetTreeNode$1__get_Right(t);
            continue SetTreeModule_iter;
        }
        else {
            f(SetTree$1__get_Key(t));
        }
        break;
    }
}

export function SetTreeModule_foldBackOpt(f_mut, t_mut, x_mut) {
    SetTreeModule_foldBackOpt:
    while (true) {
        const f = f_mut, t = t_mut, x = x_mut;
        if (t == null) {
            return x;
        }
        else if (t instanceof SetTreeNode$1) {
            f_mut = f;
            t_mut = SetTreeNode$1__get_Left(t);
            x_mut = f(SetTree$1__get_Key(t), SetTreeModule_foldBackOpt(f, SetTreeNode$1__get_Right(t), x));
            continue SetTreeModule_foldBackOpt;
        }
        else {
            return f(SetTree$1__get_Key(t), x);
        }
        break;
    }
}

export function SetTreeModule_foldBack(f, m, x) {
    return SetTreeModule_foldBackOpt(f, m, x);
}

export function SetTreeModule_foldOpt(f_mut, x_mut, t_mut) {
    SetTreeModule_foldOpt:
    while (true) {
        const f = f_mut, x = x_mut, t = t_mut;
        if (t == null) {
            return x;
        }
        else if (t instanceof SetTreeNode$1) {
            const x_1 = SetTreeModule_foldOpt(f, x, SetTreeNode$1__get_Left(t));
            const x_2 = f(x_1, SetTree$1__get_Key(t));
            f_mut = f;
            x_mut = x_2;
            t_mut = SetTreeNode$1__get_Right(t);
            continue SetTreeModule_foldOpt;
        }
        else {
            return f(x, SetTree$1__get_Key(t));
        }
        break;
    }
}

export function SetTreeModule_fold(f, x, m) {
    return SetTreeModule_foldOpt(f, x, m);
}

export function SetTreeModule_forall(f_mut, t_mut) {
    SetTreeModule_forall:
    while (true) {
        const f = f_mut, t = t_mut;
        if (t == null) {
            return true;
        }
        else if (t instanceof SetTreeNode$1) {
            if (f(SetTree$1__get_Key(t)) ? SetTreeModule_forall(f, SetTreeNode$1__get_Left(t)) : false) {
                f_mut = f;
                t_mut = SetTreeNode$1__get_Right(t);
                continue SetTreeModule_forall;
            }
            else {
                return false;
            }
        }
        else {
            return f(SetTree$1__get_Key(t));
        }
        break;
    }
}

export function SetTreeModule_exists(f_mut, t_mut) {
    SetTreeModule_exists:
    while (true) {
        const f = f_mut, t = t_mut;
        if (t == null) {
            return false;
        }
        else if (t instanceof SetTreeNode$1) {
            if (f(SetTree$1__get_Key(t)) ? true : SetTreeModule_exists(f, SetTreeNode$1__get_Left(t))) {
                return true;
            }
            else {
                f_mut = f;
                t_mut = SetTreeNode$1__get_Right(t);
                continue SetTreeModule_exists;
            }
        }
        else {
            return f(SetTree$1__get_Key(t));
        }
        break;
    }
}

export function SetTreeModule_subset(comparer, a, b) {
    return SetTreeModule_forall((x) => SetTreeModule_mem(comparer, x, b), a);
}

export function SetTreeModule_properSubset(comparer, a, b) {
    if (SetTreeModule_forall((x) => SetTreeModule_mem(comparer, x, b), a)) {
        return SetTreeModule_exists((x_1) => (!SetTreeModule_mem(comparer, x_1, a)), b);
    }
    else {
        return false;
    }
}

export function SetTreeModule_filterAux(comparer_mut, f_mut, t_mut, acc_mut) {
    SetTreeModule_filterAux:
    while (true) {
        const comparer = comparer_mut, f = f_mut, t = t_mut, acc = acc_mut;
        if (t == null) {
            return acc;
        }
        else if (t instanceof SetTreeNode$1) {
            const acc_1 = f(SetTree$1__get_Key(t)) ? SetTreeModule_add(comparer, SetTree$1__get_Key(t), acc) : acc;
            comparer_mut = comparer;
            f_mut = f;
            t_mut = SetTreeNode$1__get_Left(t);
            acc_mut = SetTreeModule_filterAux(comparer, f, SetTreeNode$1__get_Right(t), acc_1);
            continue SetTreeModule_filterAux;
        }
        else if (f(SetTree$1__get_Key(t))) {
            return SetTreeModule_add(comparer, SetTree$1__get_Key(t), acc);
        }
        else {
            return acc;
        }
        break;
    }
}

export function SetTreeModule_filter(comparer, f, s) {
    return SetTreeModule_filterAux(comparer, f, s, SetTreeModule_empty());
}

export function SetTreeModule_diffAux(comparer_mut, t_mut, acc_mut) {
    SetTreeModule_diffAux:
    while (true) {
        const comparer = comparer_mut, t = t_mut, acc = acc_mut;
        if (acc == null) {
            return acc;
        }
        else if (t == null) {
            return acc;
        }
        else if (t instanceof SetTreeNode$1) {
            comparer_mut = comparer;
            t_mut = SetTreeNode$1__get_Left(t);
            acc_mut = SetTreeModule_diffAux(comparer, SetTreeNode$1__get_Right(t), SetTreeModule_remove(comparer, SetTree$1__get_Key(t), acc));
            continue SetTreeModule_diffAux;
        }
        else {
            return SetTreeModule_remove(comparer, SetTree$1__get_Key(t), acc);
        }
        break;
    }
}

export function SetTreeModule_diff(comparer, a, b) {
    return SetTreeModule_diffAux(comparer, b, a);
}

export function SetTreeModule_union(comparer, t1, t2) {
    if (t1 == null) {
        return t2;
    }
    else if (t2 == null) {
        return t1;
    }
    else if (t1 instanceof SetTreeNode$1) {
        if (t2 instanceof SetTreeNode$1) {
            if (SetTreeNode$1__get_Height(t1) > SetTreeNode$1__get_Height(t2)) {
                const patternInput = SetTreeModule_split(comparer, SetTree$1__get_Key(t1), t2);
                return SetTreeModule_balance(comparer, SetTreeModule_union(comparer, SetTreeNode$1__get_Left(t1), patternInput[0]), SetTree$1__get_Key(t1), SetTreeModule_union(comparer, SetTreeNode$1__get_Right(t1), patternInput[2]));
            }
            else {
                const patternInput_1 = SetTreeModule_split(comparer, SetTree$1__get_Key(t2), t1);
                return SetTreeModule_balance(comparer, SetTreeModule_union(comparer, SetTreeNode$1__get_Left(t2), patternInput_1[0]), SetTree$1__get_Key(t2), SetTreeModule_union(comparer, SetTreeNode$1__get_Right(t2), patternInput_1[2]));
            }
        }
        else {
            return SetTreeModule_add(comparer, SetTree$1__get_Key(t2), t1);
        }
    }
    else {
        return SetTreeModule_add(comparer, SetTree$1__get_Key(t1), t2);
    }
}

export function SetTreeModule_intersectionAux(comparer_mut, b_mut, t_mut, acc_mut) {
    SetTreeModule_intersectionAux:
    while (true) {
        const comparer = comparer_mut, b = b_mut, t = t_mut, acc = acc_mut;
        if (t == null) {
            return acc;
        }
        else if (t instanceof SetTreeNode$1) {
            const acc_1 = SetTreeModule_intersectionAux(comparer, b, SetTreeNode$1__get_Right(t), acc);
            const acc_2 = SetTreeModule_mem(comparer, SetTree$1__get_Key(t), b) ? SetTreeModule_add(comparer, SetTree$1__get_Key(t), acc_1) : acc_1;
            comparer_mut = comparer;
            b_mut = b;
            t_mut = SetTreeNode$1__get_Left(t);
            acc_mut = acc_2;
            continue SetTreeModule_intersectionAux;
        }
        else if (SetTreeModule_mem(comparer, SetTree$1__get_Key(t), b)) {
            return SetTreeModule_add(comparer, SetTree$1__get_Key(t), acc);
        }
        else {
            return acc;
        }
        break;
    }
}

export function SetTreeModule_intersection(comparer, a, b) {
    return SetTreeModule_intersectionAux(comparer, b, a, SetTreeModule_empty());
}

export function SetTreeModule_partition1(comparer, f, k, acc1, acc2) {
    if (f(k)) {
        return [SetTreeModule_add(comparer, k, acc1), acc2];
    }
    else {
        return [acc1, SetTreeModule_add(comparer, k, acc2)];
    }
}

export function SetTreeModule_partitionAux(comparer_mut, f_mut, t_mut, acc_0_mut, acc_1_mut) {
    SetTreeModule_partitionAux:
    while (true) {
        const comparer = comparer_mut, f = f_mut, t = t_mut, acc_0 = acc_0_mut, acc_1 = acc_1_mut;
        if (t == null) {
            return [acc_0, acc_1];
        }
        else if (t instanceof SetTreeNode$1) {
            let acc_2;
            const t_2 = SetTreeNode$1__get_Right(t);
            acc_2 = SetTreeModule_partitionAux(comparer, f, t_2, acc_0, acc_1);
            let acc_3;
            const k = SetTree$1__get_Key(t);
            acc_3 = SetTreeModule_partition1(comparer, f, k, acc_2[0], acc_2[1]);
            const t_3 = SetTreeNode$1__get_Left(t);
            comparer_mut = comparer;
            f_mut = f;
            t_mut = t_3;
            acc_0_mut = acc_3[0];
            acc_1_mut = acc_3[1];
            continue SetTreeModule_partitionAux;
        }
        else {
            const k_1 = SetTree$1__get_Key(t);
            return SetTreeModule_partition1(comparer, f, k_1, acc_0, acc_1);
        }
        break;
    }
}

export function SetTreeModule_partition(comparer, f, s) {
    return SetTreeModule_partitionAux(comparer, f, s, SetTreeModule_empty(), SetTreeModule_empty());
}

export function SetTreeModule_minimumElementAux(t_mut, n_mut) {
    SetTreeModule_minimumElementAux:
    while (true) {
        const t = t_mut, n = n_mut;
        if (t == null) {
            return n;
        }
        else if (t instanceof SetTreeNode$1) {
            t_mut = SetTreeNode$1__get_Left(t);
            n_mut = SetTree$1__get_Key(t);
            continue SetTreeModule_minimumElementAux;
        }
        else {
            return SetTree$1__get_Key(t);
        }
        break;
    }
}

export function SetTreeModule_minimumElementOpt(t) {
    if (t == null) {
        return void 0;
    }
    else if (t instanceof SetTreeNode$1) {
        return Option_some(SetTreeModule_minimumElementAux(SetTreeNode$1__get_Left(t), SetTree$1__get_Key(t)));
    }
    else {
        return Option_some(SetTree$1__get_Key(t));
    }
}

export function SetTreeModule_maximumElementAux(t_mut, n_mut) {
    SetTreeModule_maximumElementAux:
    while (true) {
        const t = t_mut, n = n_mut;
        if (t == null) {
            return n;
        }
        else if (t instanceof SetTreeNode$1) {
            t_mut = SetTreeNode$1__get_Right(t);
            n_mut = SetTree$1__get_Key(t);
            continue SetTreeModule_maximumElementAux;
        }
        else {
            return SetTree$1__get_Key(t);
        }
        break;
    }
}

export function SetTreeModule_maximumElementOpt(t) {
    if (t == null) {
        return void 0;
    }
    else if (t instanceof SetTreeNode$1) {
        return Option_some(SetTreeModule_maximumElementAux(SetTreeNode$1__get_Right(t), SetTree$1__get_Key(t)));
    }
    else {
        return Option_some(SetTree$1__get_Key(t));
    }
}

export function SetTreeModule_minimumElement(s) {
    const matchValue = SetTreeModule_minimumElementOpt(s);
    if (matchValue == null) {
        throw (new Error("Set contains no elements"));
    }
    else {
        const k = Option_value(matchValue);
        return k;
    }
}

export function SetTreeModule_maximumElement(s) {
    const matchValue = SetTreeModule_maximumElementOpt(s);
    if (matchValue == null) {
        throw (new Error("Set contains no elements"));
    }
    else {
        const k = Option_value(matchValue);
        return k;
    }
}

export class SetTreeModule_SetIterator$1 {
    constructor(stack, started) {
        this.stack = stack;
        this.started = started;
    }
}

export function SetTreeModule_SetIterator$1$reflection(gen0) {
    return Reflection_record_type("Set.SetTreeModule.SetIterator`1", [gen0], SetTreeModule_SetIterator$1, () => [["stack", Reflection_list_type(SetTree$1$reflection(gen0))], ["started", Reflection_bool_type]]);
}

export function SetTreeModule_collapseLHS(stack_mut) {
    SetTreeModule_collapseLHS:
    while (true) {
        const stack = stack_mut;
        if (stack.tail != null) {
            if (stack.head == null) {
                stack_mut = stack.tail;
                continue SetTreeModule_collapseLHS;
            }
            else if (stack.head instanceof SetTreeNode$1) {
                stack_mut = (new Types_List(SetTreeNode$1__get_Left(stack.head), new Types_List(SetTree$1_$ctor_2B595(SetTree$1__get_Key(stack.head)), new Types_List(SetTreeNode$1__get_Right(stack.head), stack.tail))));
                continue SetTreeModule_collapseLHS;
            }
            else {
                return stack;
            }
        }
        else {
            return new Types_List();
        }
        break;
    }
}

export function SetTreeModule_mkIterator(s) {
    return new SetTreeModule_SetIterator$1(SetTreeModule_collapseLHS(new Types_List(s, new Types_List())), false);
}

export function SetTreeModule_notStarted() {
    throw (new Error("Enumeration not started"));
}

export function SetTreeModule_alreadyFinished() {
    throw (new Error("Enumeration already started"));
}

export function SetTreeModule_current(i) {
    if (i.started) {
        const matchValue = i.stack;
        if (matchValue.tail == null) {
            return SetTreeModule_alreadyFinished();
        }
        else {
            return SetTree$1__get_Key(matchValue.head);
        }
    }
    else {
        return SetTreeModule_notStarted();
    }
}

export function SetTreeModule_moveNext(i) {
    if (i.started) {
        const matchValue = i.stack;
        if (matchValue.tail != null) {
            if (matchValue.head instanceof SetTreeNode$1) {
                throw (new Error("Please report error: Set iterator, unexpected stack for moveNext"));
            }
            else {
                i.stack = SetTreeModule_collapseLHS(matchValue.tail);
                return !(i.stack.tail == null);
            }
        }
        else {
            return false;
        }
    }
    else {
        i.started = true;
        return !(i.stack.tail == null);
    }
}

export function SetTreeModule_mkIEnumerator(s) {
    let i = SetTreeModule_mkIterator(s);
    return {
        ["System.Collections.Generic.IEnumerator`1.get_Current"]() {
            return SetTreeModule_current(i);
        }
        ,
        ["System.Collections.IEnumerator.get_Current"]() {
            return SetTreeModule_current(i);
        }
        ,
        ["System.Collections.IEnumerator.MoveNext"]() {
            return SetTreeModule_moveNext(i);
        }
        ,
        ["System.Collections.IEnumerator.Reset"]() {
            i = SetTreeModule_mkIterator(s);
        }
        ,
        Dispose() {
        }
        ,
    };
}

export function SetTreeModule_compareStacks(comparer_mut, l1_mut, l2_mut) {
    let t_5, t_6, t_7;
    SetTreeModule_compareStacks:
    while (true) {
        const comparer = comparer_mut, l1 = l1_mut, l2 = l2_mut;
        const cont = () => {
            let pattern_matching_result, t1_1, x1_1;
            if (l1.tail != null) {
                if (!(l1.head == null)) {
                    pattern_matching_result = 0;
                    t1_1 = l1.tail;
                    x1_1 = l1.head;
                }
                else {
                    pattern_matching_result = 1;
                }
            }
            else {
                pattern_matching_result = 1;
            }
            switch (pattern_matching_result) {
                case 0: {
                    if (x1_1 instanceof SetTreeNode$1) {
                        return SetTreeModule_compareStacks(comparer, new Types_List(SetTreeNode$1__get_Left(x1_1), new Types_List(SetTreeNode$1_$ctor_Z7A150ED7(SetTree$1__get_Key(x1_1), SetTreeModule_empty(), SetTreeNode$1__get_Right(x1_1), 0), t1_1)), l2) | 0;
                    }
                    else {
                        return SetTreeModule_compareStacks(comparer, new Types_List(SetTreeModule_empty(), new Types_List(SetTree$1_$ctor_2B595(SetTree$1__get_Key(x1_1)), t1_1)), l2) | 0;
                    }
                }
                case 1: {
                    let pattern_matching_result_1, t2_1, x2_1;
                    if (l2.tail != null) {
                        if (!(l2.head == null)) {
                            pattern_matching_result_1 = 0;
                            t2_1 = l2.tail;
                            x2_1 = l2.head;
                        }
                        else {
                            pattern_matching_result_1 = 1;
                        }
                    }
                    else {
                        pattern_matching_result_1 = 1;
                    }
                    switch (pattern_matching_result_1) {
                        case 0: {
                            if (x2_1 instanceof SetTreeNode$1) {
                                return SetTreeModule_compareStacks(comparer, l1, new Types_List(SetTreeNode$1__get_Left(x2_1), new Types_List(SetTreeNode$1_$ctor_Z7A150ED7(SetTree$1__get_Key(x2_1), SetTreeModule_empty(), SetTreeNode$1__get_Right(x2_1), 0), t2_1))) | 0;
                            }
                            else {
                                return SetTreeModule_compareStacks(comparer, l1, new Types_List(SetTreeModule_empty(), new Types_List(SetTree$1_$ctor_2B595(SetTree$1__get_Key(x2_1)), t2_1))) | 0;
                            }
                        }
                        case 1: {
                            throw (new Error("unexpected state in SetTree.compareStacks"));
                        }
                    }
                }
            }
        };
        if (l1.tail != null) {
            if (l2.tail != null) {
                if (l1.head == null) {
                    if (l2.head == null) {
                        comparer_mut = comparer;
                        l1_mut = l1.tail;
                        l2_mut = l2.tail;
                        continue SetTreeModule_compareStacks;
                    }
                    else {
                        return cont() | 0;
                    }
                }
                else if (l2.head == null) {
                    return cont() | 0;
                }
                else if (l1.head instanceof SetTreeNode$1) {
                    if (t_5 = SetTreeNode$1__get_Left(l1.head), t_5 == null) {
                        if (l2.head instanceof SetTreeNode$1) {
                            if (t_6 = SetTreeNode$1__get_Left(l2.head), t_6 == null) {
                                const c = comparer.Compare(SetTree$1__get_Key(l1.head), SetTree$1__get_Key(l2.head)) | 0;
                                if (c !== 0) {
                                    return c | 0;
                                }
                                else {
                                    comparer_mut = comparer;
                                    l1_mut = (new Types_List(SetTreeNode$1__get_Right(l1.head), l1.tail));
                                    l2_mut = (new Types_List(SetTreeNode$1__get_Right(l2.head), l2.tail));
                                    continue SetTreeModule_compareStacks;
                                }
                            }
                            else {
                                return cont() | 0;
                            }
                        }
                        else {
                            const c_1 = comparer.Compare(SetTree$1__get_Key(l1.head), SetTree$1__get_Key(l2.head)) | 0;
                            if (c_1 !== 0) {
                                return c_1 | 0;
                            }
                            else {
                                comparer_mut = comparer;
                                l1_mut = (new Types_List(SetTreeNode$1__get_Right(l1.head), l1.tail));
                                l2_mut = (new Types_List(SetTreeModule_empty(), l2.tail));
                                continue SetTreeModule_compareStacks;
                            }
                        }
                    }
                    else {
                        return cont() | 0;
                    }
                }
                else if (l2.head instanceof SetTreeNode$1) {
                    if (t_7 = SetTreeNode$1__get_Left(l2.head), t_7 == null) {
                        const c_2 = comparer.Compare(SetTree$1__get_Key(l1.head), SetTree$1__get_Key(l2.head)) | 0;
                        if (c_2 !== 0) {
                            return c_2 | 0;
                        }
                        else {
                            comparer_mut = comparer;
                            l1_mut = (new Types_List(SetTreeModule_empty(), l1.tail));
                            l2_mut = (new Types_List(SetTreeNode$1__get_Right(l2.head), l2.tail));
                            continue SetTreeModule_compareStacks;
                        }
                    }
                    else {
                        return cont() | 0;
                    }
                }
                else {
                    const c_3 = comparer.Compare(SetTree$1__get_Key(l1.head), SetTree$1__get_Key(l2.head)) | 0;
                    if (c_3 !== 0) {
                        return c_3 | 0;
                    }
                    else {
                        comparer_mut = comparer;
                        l1_mut = l1.tail;
                        l2_mut = l2.tail;
                        continue SetTreeModule_compareStacks;
                    }
                }
            }
            else {
                return 1;
            }
        }
        else if (l2.tail == null) {
            return 0;
        }
        else {
            return -1;
        }
        break;
    }
}

export function SetTreeModule_compare(comparer, t1, t2) {
    if (t1 == null) {
        if (t2 == null) {
            return 0;
        }
        else {
            return -1;
        }
    }
    else if (t2 == null) {
        return 1;
    }
    else {
        return SetTreeModule_compareStacks(comparer, new Types_List(t1, new Types_List()), new Types_List(t2, new Types_List())) | 0;
    }
}

export function SetTreeModule_choose(s) {
    return SetTreeModule_minimumElement(s);
}

export function SetTreeModule_toList(t) {
    const loop = (t$0027_mut, acc_mut) => {
        loop:
        while (true) {
            const t$0027 = t$0027_mut, acc = acc_mut;
            if (t$0027 == null) {
                return acc;
            }
            else if (t$0027 instanceof SetTreeNode$1) {
                t$0027_mut = SetTreeNode$1__get_Left(t$0027);
                acc_mut = (new Types_List(SetTree$1__get_Key(t$0027), loop(SetTreeNode$1__get_Right(t$0027), acc)));
                continue loop;
            }
            else {
                return new Types_List(SetTree$1__get_Key(t$0027), acc);
            }
            break;
        }
    };
    return loop(t, new Types_List());
}

export function SetTreeModule_copyToArray(s, arr, i) {
    let j = i | 0;
    SetTreeModule_iter((x) => {
        arr[j] = x;
        j = (j + 1);
    }, s);
}

export function SetTreeModule_toArray(s) {
    const n = SetTreeModule_count(s) | 0;
    const res = new Array(n);
    SetTreeModule_copyToArray(s, res, 0);
    return res;
}

export function SetTreeModule_mkFromEnumerator(comparer_mut, acc_mut, e_mut) {
    SetTreeModule_mkFromEnumerator:
    while (true) {
        const comparer = comparer_mut, acc = acc_mut, e = e_mut;
        if (e["System.Collections.IEnumerator.MoveNext"]()) {
            comparer_mut = comparer;
            acc_mut = SetTreeModule_add(comparer, e["System.Collections.Generic.IEnumerator`1.get_Current"](), acc);
            e_mut = e;
            continue SetTreeModule_mkFromEnumerator;
        }
        else {
            return acc;
        }
        break;
    }
}

export function SetTreeModule_ofSeq(comparer, c) {
    const ie = Seq_getEnumerator(c);
    try {
        return SetTreeModule_mkFromEnumerator(comparer, SetTreeModule_empty(), ie);
    }
    finally {
        ie.Dispose();
    }
}

export function SetTreeModule_ofArray(comparer, l) {
    return Array_fold((acc, k) => SetTreeModule_add(comparer, k, acc), SetTreeModule_empty(), l);
}

export class FSharpSet {
    constructor(comparer, tree) {
        this.comparer = comparer;
        this.tree = tree;
    }
    GetHashCode() {
        const this$ = this;
        return FSharpSet__ComputeHashCode(this$) | 0;
    }
    Equals(that) {
        const this$ = this;
        if (that instanceof FSharpSet) {
            const e1 = Seq_getEnumerator(this$);
            try {
                const e2 = Seq_getEnumerator(that);
                try {
                    const loop = () => {
                        const m1 = e1["System.Collections.IEnumerator.MoveNext"]();
                        const m2 = e2["System.Collections.IEnumerator.MoveNext"]();
                        if (m1 === m2) {
                            if (!m1) {
                                return true;
                            }
                            else if (Util_equals(e1["System.Collections.Generic.IEnumerator`1.get_Current"](), e2["System.Collections.Generic.IEnumerator`1.get_Current"]())) {
                                return loop();
                            }
                            else {
                                return false;
                            }
                        }
                        else {
                            return false;
                        }
                    };
                    return loop();
                }
                finally {
                    e2.Dispose();
                }
            }
            finally {
                e1.Dispose();
            }
        }
        else {
            return false;
        }
    }
    ToString() {
        let strings;
        const this$ = this;
        return ("set [" + (strings = Seq_map((x) => {
            let copyOfStruct = x;
            return String_toString(copyOfStruct);
        }, this$), (String_join("; ", strings)))) + "]";
    }
    toString() {
        return this.ToString();
    }
    CompareTo(that) {
        const this$ = this;
        return SetTreeModule_compare(FSharpSet__get_Comparer(this$), FSharpSet__get_Tree(this$), FSharpSet__get_Tree(that)) | 0;
    }
    GetEnumerator() {
        const s = this;
        return SetTreeModule_mkIEnumerator(FSharpSet__get_Tree(s));
    }
    [Symbol.iterator]() {
        return Seq_toIterator(this.GetEnumerator());
    }
    ["System.Collections.IEnumerable.GetEnumerator"]() {
        const s = this;
        return SetTreeModule_mkIEnumerator(FSharpSet__get_Tree(s));
    }
}

export function FSharpSet$reflection(gen0) {
    return Reflection_class_type("Set.FSharpSet", [gen0], FSharpSet);
}

export function FSharpSet_$ctor_2528C5CB(comparer, tree) {
    return new FSharpSet(comparer, tree);
}

export function FSharpSet__get_Comparer(set$) {
    return set$.comparer;
}

export function FSharpSet__get_Tree(set$) {
    return set$.tree;
}

export function FSharpSet_Empty_Z41E180BF(comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_empty());
}

export function FSharpSet__Add_2B595(s, value) {
    return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), SetTreeModule_add(FSharpSet__get_Comparer(s), value, FSharpSet__get_Tree(s)));
}

export function FSharpSet__Remove_2B595(s, value) {
    return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), SetTreeModule_remove(FSharpSet__get_Comparer(s), value, FSharpSet__get_Tree(s)));
}

export function FSharpSet__get_Count(s) {
    return SetTreeModule_count(FSharpSet__get_Tree(s));
}

export function FSharpSet__Contains_2B595(s, value) {
    return SetTreeModule_mem(FSharpSet__get_Comparer(s), value, FSharpSet__get_Tree(s));
}

export function FSharpSet__Iterate_5028453F(s, x) {
    SetTreeModule_iter(x, FSharpSet__get_Tree(s));
}

export function FSharpSet__Fold(s, f, z) {
    const f_1 = f;
    return SetTreeModule_fold((x, z_1) => f_1(z_1, x), z, FSharpSet__get_Tree(s));
}

export function FSharpSet__get_IsEmpty(s) {
    const t = FSharpSet__get_Tree(s);
    return t == null;
}

export function FSharpSet__Partition_Z1D55A0D7(s, f) {
    let t;
    if (t = FSharpSet__get_Tree(s), t == null) {
        return [s, s];
    }
    else {
        const patternInput = SetTreeModule_partition(FSharpSet__get_Comparer(s), f, FSharpSet__get_Tree(s));
        return [FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), patternInput[0]), FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), patternInput[1])];
    }
}

export function FSharpSet__Filter_Z1D55A0D7(s, f) {
    let t;
    if (t = FSharpSet__get_Tree(s), t == null) {
        return s;
    }
    else {
        return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), SetTreeModule_filter(FSharpSet__get_Comparer(s), f, FSharpSet__get_Tree(s)));
    }
}

export function FSharpSet__Map_7597B8F7(s, f, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_fold((acc, k) => SetTreeModule_add(comparer, f(k), acc), SetTreeModule_empty(), FSharpSet__get_Tree(s)));
}

export function FSharpSet__Exists_Z1D55A0D7(s, f) {
    return SetTreeModule_exists(f, FSharpSet__get_Tree(s));
}

export function FSharpSet__ForAll_Z1D55A0D7(s, f) {
    return SetTreeModule_forall(f, FSharpSet__get_Tree(s));
}

export function FSharpSet_op_Subtraction(set1, set2) {
    let t, t_1;
    if (t = FSharpSet__get_Tree(set1), t == null) {
        return set1;
    }
    else if (t_1 = FSharpSet__get_Tree(set2), t_1 == null) {
        return set1;
    }
    else {
        return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(set1), SetTreeModule_diff(FSharpSet__get_Comparer(set1), FSharpSet__get_Tree(set1), FSharpSet__get_Tree(set2)));
    }
}

export function FSharpSet_op_Addition(set1, set2) {
    let t, t_1;
    if (t = FSharpSet__get_Tree(set2), t == null) {
        return set1;
    }
    else if (t_1 = FSharpSet__get_Tree(set1), t_1 == null) {
        return set2;
    }
    else {
        return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(set1), SetTreeModule_union(FSharpSet__get_Comparer(set1), FSharpSet__get_Tree(set1), FSharpSet__get_Tree(set2)));
    }
}

export function FSharpSet_Intersection_Z3BE9BFE0(a, b) {
    let t, t_1;
    if (t = FSharpSet__get_Tree(b), t == null) {
        return b;
    }
    else if (t_1 = FSharpSet__get_Tree(a), t_1 == null) {
        return a;
    }
    else {
        return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(a), SetTreeModule_intersection(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b)));
    }
}

export function FSharpSet_Intersection_Z15B59630(sets) {
    return Seq_reduce(FSharpSet_Intersection_Z3BE9BFE0, sets);
}

export function FSharpSet_Equality_Z3BE9BFE0(a, b) {
    return SetTreeModule_compare(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b)) === 0;
}

export function FSharpSet_Compare_Z3BE9BFE0(a, b) {
    return SetTreeModule_compare(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b));
}

export function FSharpSet__get_Choose(x) {
    return SetTreeModule_choose(FSharpSet__get_Tree(x));
}

export function FSharpSet__get_MinimumElement(x) {
    return SetTreeModule_minimumElement(FSharpSet__get_Tree(x));
}

export function FSharpSet__get_MaximumElement(x) {
    return SetTreeModule_maximumElement(FSharpSet__get_Tree(x));
}

export function FSharpSet__IsSubsetOf_6A20B1FF(x, otherSet) {
    return SetTreeModule_subset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(x), FSharpSet__get_Tree(otherSet));
}

export function FSharpSet__IsSupersetOf_6A20B1FF(x, otherSet) {
    return SetTreeModule_subset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(otherSet), FSharpSet__get_Tree(x));
}

export function FSharpSet__IsProperSubsetOf_6A20B1FF(x, otherSet) {
    return SetTreeModule_properSubset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(x), FSharpSet__get_Tree(otherSet));
}

export function FSharpSet__IsProperSupersetOf_6A20B1FF(x, otherSet) {
    return SetTreeModule_properSubset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(otherSet), FSharpSet__get_Tree(x));
}

export function FSharpSet__ToList(x) {
    return SetTreeModule_toList(FSharpSet__get_Tree(x));
}

export function FSharpSet__ToArray(x) {
    return SetTreeModule_toArray(FSharpSet__get_Tree(x));
}

export function FSharpSet__ComputeHashCode(this$) {
    let res = 0;
    const enumerator = Seq_getEnumerator(this$);
    try {
        while (enumerator["System.Collections.IEnumerator.MoveNext"]()) {
            const x_1 = enumerator["System.Collections.Generic.IEnumerator`1.get_Current"]();
            const x = res | 0;
            const y = Util_structuralHash(x_1) | 0;
            res = (((x << 1) + y) + 631);
        }
    }
    finally {
        enumerator.Dispose();
    }
    return Math.abs(res) | 0;
}

export function isEmpty(set$) {
    return FSharpSet__get_IsEmpty(set$);
}

export function contains(element, set$) {
    return FSharpSet__Contains_2B595(set$, element);
}

export function add(value, set$) {
    return FSharpSet__Add_2B595(set$, value);
}

export function singleton(value, comparer) {
    return FSharpSet__Add_2B595(FSharpSet_Empty_Z41E180BF(comparer), value);
}

export function remove(value, set$) {
    return FSharpSet__Remove_2B595(set$, value);
}

export function union(set1, set2) {
    return FSharpSet_op_Addition(set1, set2);
}

export function unionMany(sets, comparer) {
    return Seq_fold(FSharpSet_op_Addition, FSharpSet_Empty_Z41E180BF(comparer), sets);
}

export function intersect(set1, set2) {
    return FSharpSet_Intersection_Z3BE9BFE0(set1, set2);
}

export function intersectMany(sets) {
    return FSharpSet_Intersection_Z15B59630(sets);
}

export function iterate(action, set$) {
    FSharpSet__Iterate_5028453F(set$, action);
}

export function empty(comparer) {
    return FSharpSet_Empty_Z41E180BF(comparer);
}

export function forAll(predicate, set$) {
    return FSharpSet__ForAll_Z1D55A0D7(set$, predicate);
}

export function exists(predicate, set$) {
    return FSharpSet__Exists_Z1D55A0D7(set$, predicate);
}

export function filter(predicate, set$) {
    return FSharpSet__Filter_Z1D55A0D7(set$, predicate);
}

export function partition(predicate, set$) {
    return FSharpSet__Partition_Z1D55A0D7(set$, predicate);
}

export function fold(folder, state, set$) {
    return SetTreeModule_fold(folder, state, FSharpSet__get_Tree(set$));
}

export function foldBack(folder, set$, state) {
    return SetTreeModule_foldBack(folder, FSharpSet__get_Tree(set$), state);
}

export function map(mapping, set$, comparer) {
    return FSharpSet__Map_7597B8F7(set$, mapping, comparer);
}

export function count(set$) {
    return FSharpSet__get_Count(set$);
}

export function ofList(elements, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_ofSeq(comparer, elements));
}

export function ofArray(array, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_ofArray(comparer, array));
}

export function toList(set$) {
    return FSharpSet__ToList(set$);
}

export function toArray(set$) {
    return FSharpSet__ToArray(set$);
}

export function toSeq(set$) {
    return set$;
}

export function ofSeq(elements, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_ofSeq(comparer, elements));
}

export function difference(set1, set2) {
    return FSharpSet_op_Subtraction(set1, set2);
}

export function isSubset(set1, set2) {
    return SetTreeModule_subset(FSharpSet__get_Comparer(set1), FSharpSet__get_Tree(set1), FSharpSet__get_Tree(set2));
}

export function isSuperset(set1, set2) {
    return SetTreeModule_subset(FSharpSet__get_Comparer(set1), FSharpSet__get_Tree(set2), FSharpSet__get_Tree(set1));
}

export function isProperSubset(set1, set2) {
    return SetTreeModule_properSubset(FSharpSet__get_Comparer(set1), FSharpSet__get_Tree(set1), FSharpSet__get_Tree(set2));
}

export function isProperSuperset(set1, set2) {
    return SetTreeModule_properSubset(FSharpSet__get_Comparer(set1), FSharpSet__get_Tree(set2), FSharpSet__get_Tree(set1));
}

export function minElement(set$) {
    return FSharpSet__get_MinimumElement(set$);
}

export function maxElement(set$) {
    return FSharpSet__get_MaximumElement(set$);
}

export function createMutable(source, comparer) {
    const set$ = MutableSet_HashSet_$ctor_Z6150332D(source, comparer);
    return set$;
}

export function distinct(xs, comparer) {
    return Seq_delay(() => {
        const set$ = MutableSet_HashSet_$ctor_Z6150332D(Seq_empty(), comparer);
        return Seq_collect((x) => (MutableSet_HashSet__Add_2B595(set$, x) ? Seq_singleton(x) : Seq_empty()), xs);
    });
}

export function distinctBy(projection, xs, comparer) {
    return Seq_delay(() => {
        const set$ = MutableSet_HashSet_$ctor_Z6150332D(Seq_empty(), comparer);
        return Seq_collect((x) => (MutableSet_HashSet__Add_2B595(set$, projection(x)) ? Seq_singleton(x) : Seq_empty()), xs);
    });
}

export function unionWith(s1, s2) {
    return Seq_fold((acc, x) => acc.add(x), s1, s2);
}

export function intersectWith(s1, s2, comparer) {
    const s2_1 = ofSeq(s2, comparer);
    const enumerator = Seq_getEnumerator(s1);
    try {
        while (enumerator["System.Collections.IEnumerator.MoveNext"]()) {
            const x = enumerator["System.Collections.Generic.IEnumerator`1.get_Current"]();
            if (!FSharpSet__Contains_2B595(s2_1, x)) {
                const value = s1.delete(x);
                void value;
            }
            else {
            }
        }
    }
    finally {
        enumerator.Dispose();
    }
}

export function exceptWith(s1, s2) {
    const enumerator = Seq_getEnumerator(s2);
    try {
        while (enumerator["System.Collections.IEnumerator.MoveNext"]()) {
            const x = enumerator["System.Collections.Generic.IEnumerator`1.get_Current"]();
            const value = s1.delete(x);
            void value;
        }
    }
    finally {
        enumerator.Dispose();
    }
}

export function isSubsetOf(s1, s2, comparer) {
    return isSubset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

export function isSupersetOf(s1, s2, comparer) {
    return isSuperset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

export function isProperSubsetOf(s1, s2, comparer) {
    return isProperSubset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

export function isProperSupersetOf(s1, s2, comparer) {
    return isProperSuperset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

